package eu.mhsl.minenet.minigames.instance.game.stateless.config;

import eu.mhsl.minenet.minigames.instance.game.stateless.StatelessGame;
import eu.mhsl.minenet.minigames.instance.game.stateless.config.restriction.RestrictionHandler;
import eu.mhsl.minenet.minigames.message.component.TranslatedComponent;
import net.minestom.server.item.Material;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public interface GameFactory {
    TranslatedComponent name();
    default ConfigManager configuration() {
        return null;
    }
    default RestrictionHandler globalRestrictions() {
        return new RestrictionHandler();
    }

    default Material symbol() {
        return Material.GRASS_BLOCK;
    }
    default TranslatedComponent description() {
        return TranslatedComponent.byId("GameFactory#missingDescription");
    }

    StatelessGame manufacture(Map<String, Option<?>> configuration) throws Exception;

    default StatelessGame manufacture(List<Option<?>> configuration) throws Exception {
        if(configuration == null) return manufacture();

        Map<String, Option<?>> cnf = new HashMap<>();
        configuration.forEach(option -> cnf.put(option.getId(), option));

        return manufacture(cnf);
    }

    default StatelessGame manufacture() throws Exception {
        if(this.configuration() == null) return manufacture(List.of());

        return manufacture(this.configuration().getAll());
    }
}
